package test.bank;

import java.util.Hashtable;
import java.util.List;

import javax.naming.Context;
import javax.naming.InitialContext;

import com.sun.appserv.security.ProgrammaticLogin;
import com.webage.ejbs.bank.account.Account;
import com.webage.ejbs.bank.account.AccountManager;
import com.webage.ejbs.bank.account.AccountManagerRemote;
import com.webage.ejbs.hello.Hello;

public class ClientBank {
	static private void afficheMessageCreation(int accountNb) {
		System.err.println("Account " + accountNb + " created");
	}

	public static void main(String args[]) {
		try {
			/*ProgrammaticLogin login = new ProgrammaticLogin();
			login.login("user", "user");*/

			InitialContext jndiContext = new InitialContext();

			AccountManagerRemote am = (AccountManagerRemote) jndiContext
					.lookup("ejb/accountManagerJNDI");

			int account1ID, account2ID, account3ID;
			afficheMessageCreation(account1ID = am.createAccount(50));
			afficheMessageCreation(account3ID = am.createAccount(250));
			afficheMessageCreation(account2ID = am.createAccount(150));

			List<Account> la = am.findAccountLargerThan(100);
			System.out.println(la);

			// Attention à la modification d'objets remote persistants !!!
			Account a = am.getAccount(account1ID);
			a.credit(500);
			am.updateAccount(a);

			// Bien Mieux
			am.credit(account3ID, 50);

			la = am.findAccountLargerThan(100);
			System.out.println(la);

			am.closeAccount(account1ID);
			am.closeAccount(account2ID);
			am.closeAccount(account3ID);

			javax.swing.JOptionPane.showMessageDialog(null, am.restricted());

		} catch (Exception e) {
			e.printStackTrace();
		}

	}
}
