package com.webage.ejbs.bank.account;

import java.io.Serializable;
import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EJBHome;
import javax.ejb.EJBObject;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.Handle;
import javax.ejb.RemoveException;
import javax.ejb.Stateless;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Version;

@Entity
// @Table(name="ACCOUNT")
public class Account implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1718293603285534212L;

	@Id
	@GeneratedValue
	// @Column(name="ACCOUNT_PK")
	public int accountNb;

	@Version
	int oplock;

	// Persistance Implicite même sans annotation
	public double balance;

	// Obligatoire pour la création
	protected Account() {
	}

	protected Account(double balance) {
		this.balance = balance;
	}

	public void credit(double amount) {
		balance += amount;
	}

	public void debit(double amount) {
		balance -= amount;
	}

	@Override
	public String toString() {
		return "Account(" + accountNb + "," + balance + "€)["
				+ super.toString() + "]";
	}

	
	
}
